<template>
  <v-card style="height: calc(1vh-200px); width:100%; padding: 1px;" class="mx-auto" tile>
    <l-map
      style="height: 100%; width:100%;"
      ref="map"
      v-if="showMap"
      :zoom="zoom"
      :center="center"
      :options="mapOptions"
      @update:center="centerUpdate"
      @update:zoom="zoomUpdate"
    >
      <l-tile-layer :url="url" :attribution="attribution" />
      <l-marker
        v-for="coord in airportsLocation"
        :lat-lng="coord"
        :key="coord.toString()"
        :icon="planeicon"
      >
      </l-marker>
    </l-map>
  </v-card>
</template>

<script>
import { latLng, icon, latLngBounds } from "leaflet";
import "leaflet/dist/leaflet.css";

import { LMap, LTileLayer, LMarker } from "vue2-leaflet";

export default {
  name: "Map",
  components: {
    LMap,
    LTileLayer,
    LMarker,
  },
  data() {
    return {
      zoom: 5,
      center: latLng(47.41322, -1.219482),
      url: "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",
      attribution:
        '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
      currentZoom: 11.5,
      currentCenter: latLng(47.41322, -1.219482),
      showParagraph: false,
      mapOptions: {
        zoomSnap: 0.5,
        maxZoom: 9
      },
      showMap: true,
      planeicon: icon({
        iconUrl: require("../assets/plane-pin.png"),
        iconSize: [60, 60],
        iconAnchor: [30, 60],
      }),
    };
  },
  computed: {
    airportsLocation: {
      get() {
        let locs = this.$store.getters.getChoosenAirportsLocation;
        return Object.values(locs).map((coord) => latLng(coord.lat, coord.lng));
      },
    },
  },
  methods: {
    zoomUpdate(zoom) {
      this.currentZoom = zoom;
    },
    centerUpdate(center) {
      this.currentCenter = center;
    },
  },
  watch: {
    airportsLocation: function(val) {
      if (!val || val.length == 0) return;

      this.$refs.map.fitBounds(new latLngBounds(val).pad(0.2));
    },
  },
  mounted() {
    setTimeout(() => this.$refs.map.mapObject.invalidateSize(true), 500);
  },
};
</script>
